/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package de.jugms.sd.components.panels;


/**
 *
 * @author hansolo
 */
public class SDGlassPane extends javax.swing.JComponent
{
    private boolean disabled = false;
    private Thread pulser = null;
    private volatile static java.awt.Color fadingColor = new java.awt.Color(0,0,0,200);
    private volatile static boolean backgroundDark = false;
    public enum MARKER_TYPE
    {
        RED_TRIANGLE,
        YELLOW_TRIANGLE,
        RED_CIRCLE,
        YELLOW_FLASH
    };
    private static final int MARKER_SIZE = 15;
    private static final int HALF_MARKER_SIZE = MARKER_SIZE / 2;
    private static final int CHECK_MARKER_SIZE = 15;
    private static final int HALF_CHECK_MARKER_SIZE = CHECK_MARKER_SIZE / 2;
    private static final int OK_MARKER_WIDTH = 22;
    private static final int OK_MARKER_HEIGHT = 18;
    private static final java.awt.Stroke BIG_STROKE = new java.awt.BasicStroke(2.0f);
    private static final java.awt.Stroke MEDIUM_STROKE = new java.awt.BasicStroke(1.5f);
    private static final java.awt.Stroke THIN_STROKE = new java.awt.BasicStroke(1.0f);
    private final java.awt.image.BufferedImage MARKER_IMAGE;
    private java.awt.image.BufferedImage checkMarkerImage = createCheckMarkImage();
    private java.awt.image.BufferedImage okMarkerImage = createOkMarkerImage();
    private static final int ALPHA = 180;
    private static final int LOGO_ALPHA = 255;
    private static float currentLogoAlpha = 1.0f;
    private static float currentLogoScale = 0.7f;
    private static float currentGlowAlpha = 0.0f;
    private java.util.Set<javax.swing.JComponent> markerComponentSet = new java.util.HashSet<javax.swing.JComponent>();
    private java.util.Set<javax.swing.JComponent> checkMarkerComponentSet = new java.util.HashSet<javax.swing.JComponent>();
    private java.util.Set<javax.swing.JComponent> okMarkerComponentSet = new java.util.HashSet<javax.swing.JComponent>();
    private java.util.Map<javax.swing.JComponent, Thread> removerThreadMap = new java.util.HashMap<javax.swing.JComponent, Thread>();
    private java.util.concurrent.ConcurrentHashMap<javax.swing.JComponent, Float> checkMarkerAlphaMap = new java.util.concurrent.ConcurrentHashMap<javax.swing.JComponent, Float>();
    private java.awt.AlphaComposite alphaComp;
    private java.awt.AlphaComposite stdComposite;
    private final java.awt.RenderingHints HINTS;
    private final java.awt.image.BufferedImage LOGO_IMAGE;
    private final java.awt.image.BufferedImage REFLECTION_IMAGE;
    private final java.awt.image.BufferedImage GLOW_IMAGE;
    private final java.awt.image.BufferedImage REFLECTION_GLOW_IMAGE;
    private float currentAlpha = 0.9f;

    public SDGlassPane()
    {
        this(MARKER_TYPE.YELLOW_TRIANGLE);
    }

    public SDGlassPane(MARKER_TYPE markerType)
    {
        HINTS = new java.awt.RenderingHints(java.awt.RenderingHints.KEY_ALPHA_INTERPOLATION, java.awt.RenderingHints.VALUE_ALPHA_INTERPOLATION_QUALITY);
        HINTS.put(java.awt.RenderingHints.KEY_ANTIALIASING, java.awt.RenderingHints.VALUE_ANTIALIAS_ON);
        HINTS.put(java.awt.RenderingHints.KEY_COLOR_RENDERING, java.awt.RenderingHints.VALUE_COLOR_RENDER_QUALITY);
        HINTS.put(java.awt.RenderingHints.KEY_INTERPOLATION, java.awt.RenderingHints.VALUE_INTERPOLATION_BILINEAR);
        HINTS.put(java.awt.RenderingHints.KEY_RENDERING, java.awt.RenderingHints.VALUE_RENDER_QUALITY);

        switch (markerType)
        {
            case YELLOW_TRIANGLE:
                MARKER_IMAGE = createAttentionMarker(MARKER_TYPE.YELLOW_TRIANGLE);
                break;
            case RED_TRIANGLE:
                MARKER_IMAGE = createAttentionMarker(MARKER_TYPE.RED_TRIANGLE);
                break;
            case RED_CIRCLE:
                MARKER_IMAGE = createAttentionMarker(MARKER_TYPE.RED_CIRCLE);
                break;
            case YELLOW_FLASH:
                MARKER_IMAGE = createAttentionMarker(MARKER_TYPE.YELLOW_FLASH);
                break;
            default:
                MARKER_IMAGE = createAttentionMarker(MARKER_TYPE.YELLOW_TRIANGLE);
                break;
        }

        this.LOGO_IMAGE = createLogoImage();
        this.REFLECTION_IMAGE = createReflectionImage(LOGO_IMAGE);
        this.GLOW_IMAGE = createGlowImage();
        this.REFLECTION_GLOW_IMAGE = createReflectionImage(GLOW_IMAGE);
    }

    @Override
    protected void paintComponent(java.awt.Graphics g)
    {
        java.awt.Graphics2D g2 = (java.awt.Graphics2D) g;
        g2.setRenderingHint(java.awt.RenderingHints.KEY_ANTIALIASING, java.awt.RenderingHints.VALUE_ANTIALIAS_ON);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_TEXT_ANTIALIASING, java.awt.RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_STROKE_CONTROL, java.awt.RenderingHints.VALUE_STROKE_PURE);

        // Draw all AttentionMarker
        drawAttentionMarker(g2);

        // Draw all CheckMarker
        drawCheckMarker(g2);

        // Draw all OK-Marker
        drawOkMarker(g2);
        
        // Disabled
        if (disabled)
        {
            drawDisabled(g2);
        }

        if (backgroundDark && !disabled)
        {            
            drawDisabled(g2);
        }

        g2.dispose();
    }

    private void drawAttentionMarker(java.awt.Graphics2D g2)
    {
        javax.swing.JComponent tmpComponent;

        // Draw all Marker
        for (javax.swing.JComponent component : this.markerComponentSet)
        {
            int originX = 0;
            int originY = 0;
            tmpComponent = component;

            while (tmpComponent.getParent() != null)
            {
                if (tmpComponent.getParent() instanceof javax.swing.JFrame)
                {
                    break;
                }
                originX += tmpComponent.getX();
                originY += tmpComponent.getY();
                tmpComponent = (javax.swing.JComponent) tmpComponent.getParent();
            }

            g2.drawImage(MARKER_IMAGE, (originX - HALF_MARKER_SIZE), (originY - HALF_MARKER_SIZE), null);
        }
    }

    private void drawCheckMarker(java.awt.Graphics2D g2)
    {
        javax.swing.JComponent tmpComponent;
        stdComposite = (java.awt.AlphaComposite) g2.getComposite();
        for (javax.swing.JComponent component : checkMarkerComponentSet)
        {
            int originX = 0;
            int originY = 0;
            float tmpAlpha;
            tmpComponent = component;
            while (tmpComponent.getParent() != null)
            {
                if (tmpComponent.getParent() instanceof javax.swing.JFrame)
                {
                    break;
                }
                originX += tmpComponent.getX();
                originY += tmpComponent.getY();
                tmpComponent = (javax.swing.JComponent) tmpComponent.getParent();
            }

            // Set the opacity for each CheckMarker
            tmpAlpha = currentAlpha;
            alphaComp = java.awt.AlphaComposite.getInstance(java.awt.AlphaComposite.SRC_OVER, currentAlpha);
            for (javax.swing.JComponent comp : checkMarkerAlphaMap.keySet())
            {
                if (comp.equals(component))
                {
                    if (component != null)
                        tmpAlpha = checkMarkerAlphaMap.get(component);
                    else
                        tmpAlpha = 1.0f;
                }
            }

            alphaComp = java.awt.AlphaComposite.getInstance(java.awt.AlphaComposite.SRC_OVER, tmpAlpha);

            g2.setComposite(alphaComp);

            g2.drawImage(checkMarkerImage, (originX - HALF_CHECK_MARKER_SIZE), (originY - HALF_CHECK_MARKER_SIZE), null);
        }
        // If there are no checkmarkers anymore
        // we remove the glasspane from the GlobalAnimationTimer
        if (checkMarkerComponentSet.isEmpty())
        {
            de.jugms.sd.tools.SDGlobalAnimationTimer.INSTANCE.removeComponent(this);
        }
        g2.setComposite(stdComposite);
    }

    private void drawOkMarker(java.awt.Graphics2D g2)
    {
        javax.swing.JComponent tmpComponent;
        for (javax.swing.JComponent component : this.okMarkerComponentSet)
        {
            int originX = 0;
            int originY = 0;
            tmpComponent = component;
            while (tmpComponent.getParent() != null)
            {
                if (tmpComponent.getParent() instanceof javax.swing.JFrame)
                {
                    break;
                }
                originX += tmpComponent.getX();
                originY += tmpComponent.getY();
                tmpComponent = (javax.swing.JComponent) tmpComponent.getParent();
            }

            g2.drawImage(okMarkerImage, (originX - OK_MARKER_WIDTH + component.getWidth()), (originY - OK_MARKER_HEIGHT), null);
        }
    }

    private void drawDisabled(java.awt.Graphics2D g2)
    {
        // Faded background
        g2.setColor(fadingColor);
        g2.fillRect(0, 0, getParent().getWidth(), getParent().getHeight());

        // JUG-LOGO
        int posX = (getWidth() - (int)(LOGO_IMAGE.getWidth() * currentLogoScale)) / 2;
        int posY = (getHeight() - ((int)(LOGO_IMAGE.getHeight() * currentLogoScale) + (int) ((int)(REFLECTION_IMAGE.getHeight() * currentLogoScale) * 0.3f))) / 2;
        int newW = (int)(LOGO_IMAGE.getWidth() * currentLogoScale);
        int newH = (int)(LOGO_IMAGE.getHeight() * currentLogoScale);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_INTERPOLATION, java.awt.RenderingHints.VALUE_INTERPOLATION_BILINEAR);

        g2.setComposite(java.awt.AlphaComposite.getInstance(java.awt.AlphaComposite.SRC_OVER, currentGlowAlpha));
        g2.drawImage(GLOW_IMAGE, posX, posY, newW, newH, null);
        g2.drawImage(REFLECTION_GLOW_IMAGE, posX, posY + (int)(LOGO_IMAGE.getHeight() * currentLogoScale) + 2, newW, newH, null);

        g2.setComposite(java.awt.AlphaComposite.getInstance(java.awt.AlphaComposite.SRC_OVER, currentLogoAlpha));
        g2.drawImage(LOGO_IMAGE, posX, posY, newW, newH, null);
        g2.drawImage(REFLECTION_IMAGE, posX, posY + (int)(LOGO_IMAGE.getHeight() * currentLogoScale) + 2, newW, newH, null);
        g2.setComposite(java.awt.AlphaComposite.getInstance(java.awt.AlphaComposite.SRC_OVER, 1.0f));
    }

    public void addMarker(javax.swing.JComponent component)
    {
        markerComponentSet.add(component);     
        if (removerThreadMap.containsKey(component))
        {
            removerThreadMap.get(component).interrupt();
        }        
        repaint();
    }
      
    public void removeMarker(javax.swing.JComponent component)
    {
        if (markerComponentSet.contains(component))
        {
            markerComponentSet.remove(component);
            checkMarkerComponentSet.add(component);
            checkMarkerAlphaMap.put(component, currentAlpha);
            de.jugms.sd.tools.SDGlobalAnimationTimer.INSTANCE.addComponent(this);            
            createCheckMarkerRemover(component).start();
        }
    }

    public void removeMarkerWithoutCheckMarker(javax.swing.JComponent component)
    {
        if (markerComponentSet.contains(component))
        {
            this.markerComponentSet.remove(component);            
            repaint();
        }
    }

    private void removeCheckMarker(javax.swing.JComponent component)
    {
        if (checkMarkerComponentSet.contains(component))
        {
            this.checkMarkerComponentSet.remove(component);
            checkMarkerAlphaMap.remove(component);            
            repaint();
        }
    }

    public boolean hasMarker(javax.swing.JComponent component)
    {
        return markerComponentSet.contains(component);
    }

    public void setDisabled(boolean disabled)
    {
        this.disabled = disabled;        
        
        // Fading Thread starten
        createFadingAnimation(disabled).start();

        // Pulsating Thread starten wenn disabled
        if (disabled)
        {
            javax.swing.SwingUtilities.invokeLater(new java.lang.Runnable()
            {

                @Override
                public void run()
                {
                    createPulsatingAnimation().start();
                }
            });
        }
    }

    public boolean isEverythingOK()
    {
        return this.markerComponentSet.isEmpty();
    }

    public void addOkMarker(javax.swing.JComponent component)
    {
        this.okMarkerComponentSet.add(component);
    }

    public void removeOkMarker(javax.swing.JComponent component)
    {
        this.okMarkerComponentSet.remove(component);        
        repaint();
    }

    public void resetGlassPane()
    {
        markerComponentSet.clear();
        checkMarkerComponentSet.clear();
        okMarkerComponentSet.clear();
        repaint();
    }

    public void refresh()
    {
        checkMarkerImage = createCheckMarkImage();
        okMarkerImage = createOkMarkerImage();
    }

    private java.awt.image.BufferedImage createAttentionMarker(MARKER_TYPE type)
    {
        java.awt.image.BufferedImage markerImage = new java.awt.image.BufferedImage(MARKER_SIZE + 4, MARKER_SIZE + 4, java.awt.image.BufferedImage.TYPE_INT_ARGB);
        java.awt.Graphics2D g2 = (java.awt.Graphics2D) markerImage.getGraphics();
        g2.setRenderingHint(java.awt.RenderingHints.KEY_STROKE_CONTROL, java.awt.RenderingHints.VALUE_STROKE_PURE);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_ANTIALIASING, java.awt.RenderingHints.VALUE_ANTIALIAS_ON);
        java.awt.Point origin = new java.awt.Point(0, 0);
        java.awt.geom.GeneralPath shape;
        java.awt.Color background;
        java.awt.Color frame;
        java.awt.Color light;
        java.awt.Color dark;
        java.awt.GradientPaint gradientBackground;
        java.awt.RadialGradientPaint gradientShadow;

        switch (type)
        {
            case RED_TRIANGLE:
                shape = new java.awt.geom.GeneralPath();
                shape.moveTo(origin.x + MARKER_SIZE / 2, origin.y);
                shape.lineTo(origin.x + MARKER_SIZE - 1, origin.y + MARKER_SIZE - 1);
                shape.lineTo(origin.x, origin.y + MARKER_SIZE - 1);
                shape.closePath();

                background = new java.awt.Color(255, 255, 255, ALPHA);
                frame = new java.awt.Color(255, 0, 0, ALPHA);

                // Marker
                g2.setColor(background);
                g2.fill(shape);
                g2.setColor(frame);
                g2.setStroke(MEDIUM_STROKE);
                g2.draw(shape);
                g2.setStroke(THIN_STROKE);
                g2.setColor(java.awt.Color.BLACK);
                g2.drawLine(origin.x + MARKER_SIZE / 2, origin.y + 4, origin.x + MARKER_SIZE / 2, origin.y + MARKER_SIZE * 3 / 4 - 2);
                g2.drawLine(origin.x + MARKER_SIZE / 2, origin.y + MARKER_SIZE * 3 / 4 + 1, origin.x + MARKER_SIZE / 2, origin.y + MARKER_SIZE - 4);
                break;

            case YELLOW_TRIANGLE:
                java.awt.geom.GeneralPath triangle = new java.awt.geom.GeneralPath();
                triangle.moveTo(origin.x + MARKER_SIZE / 2, origin.y);
                triangle.lineTo(origin.x + MARKER_SIZE - 1, origin.y + MARKER_SIZE - 1);
                triangle.lineTo(origin.x, origin.y + MARKER_SIZE - 1);
                triangle.closePath();

                background = new java.awt.Color(255, 255, 0, ALPHA);
                frame = new java.awt.Color(150, 150, 150, ALPHA);

                g2.setColor(background);
                g2.fill(triangle);
                g2.setColor(frame);
                g2.draw(triangle);
                g2.setColor(java.awt.Color.BLACK);
                g2.drawLine(origin.x + MARKER_SIZE / 2, origin.y + 4, origin.x + MARKER_SIZE / 2, origin.y + MARKER_SIZE * 3 / 4 - 2);
                g2.drawLine(origin.x + MARKER_SIZE / 2, origin.y + MARKER_SIZE * 3 / 4 + 1, origin.x + MARKER_SIZE / 2, origin.y + MARKER_SIZE - 4);
                break;

            case RED_CIRCLE:
                light = de.jugms.sd.tools.SDHelper.INSTANCE.setAlpha(de.jugms.sd.tools.SDTwoColorGradients.RED.getLight(), 180);
                dark = de.jugms.sd.tools.SDHelper.INSTANCE.setAlpha(de.jugms.sd.tools.SDTwoColorGradients.RED.getDark(), 180);

                gradientBackground = new java.awt.GradientPaint(new java.awt.Point(origin.x + 2, origin.y + 2), light, new java.awt.Point(origin.x + 2, origin.y + 18), dark);
                gradientShadow = new java.awt.RadialGradientPaint(new java.awt.Point(origin.x + MARKER_SIZE / 2 + 3, origin.y + MARKER_SIZE / 2 + 3), 7.5f, new float[]
                {
                    0.0f,
                    1.0f
                }, new java.awt.Color[]
                {
                    new java.awt.Color(0, 0, 0, 255),
                    new java.awt.Color(0, 0, 0, 20)
                });

                // Shadow
                g2.setPaint(gradientShadow);
                g2.fillOval(origin.x + 4, origin.y + 6, MARKER_SIZE, MARKER_SIZE);

                // Marker
                g2.setPaint(gradientBackground);
                g2.fillOval(origin.x + 2, origin.y + 2, MARKER_SIZE, MARKER_SIZE);
                g2.setPaint(java.awt.Color.WHITE);
                g2.setStroke(MEDIUM_STROKE);
                g2.drawOval(origin.x + 1, origin.y + 1, MARKER_SIZE, MARKER_SIZE);

                g2.drawLine(origin.x + 8, origin.y + 5, origin.x + 8, origin.y + 9);
                g2.drawLine(origin.x + 8, origin.y + 12, origin.x + 8, origin.y + 12);
                break;

            case YELLOW_FLASH:
                light = de.jugms.sd.tools.SDHelper.INSTANCE.setAlpha(de.jugms.sd.tools.SDTwoColorGradients.YELLOW.getLight(), 180);
                dark = de.jugms.sd.tools.SDHelper.INSTANCE.setAlpha(de.jugms.sd.tools.SDTwoColorGradients.YELLOW.getDark(), 180);

                gradientBackground = new java.awt.GradientPaint(new java.awt.Point(origin.x + 2, origin.y + 2), light, new java.awt.Point(origin.x + 2, origin.y + 18), dark);
                gradientShadow = new java.awt.RadialGradientPaint(new java.awt.Point(origin.x + MARKER_SIZE / 2 + 3, origin.y + MARKER_SIZE / 2 + 3), 7.5f, new float[]
                {
                    0.0f,
                    1.0f
                }, new java.awt.Color[]
                {
                    new java.awt.Color(0, 0, 0, 255),
                    new java.awt.Color(0, 0, 0, 20)
                });

                // Shadow
                g2.setPaint(gradientShadow);
                g2.fillOval(origin.x + 4, origin.y + 6, MARKER_SIZE, MARKER_SIZE);

                // Marker
                g2.setPaint(gradientBackground);
                g2.fillOval(origin.x + 2, origin.y + 2, MARKER_SIZE, MARKER_SIZE);
                g2.setPaint(new java.awt.Color(0.0f, 0.0f, 0.0f, 0.8f));
                g2.drawOval(origin.x + 2, origin.y + 2, MARKER_SIZE, MARKER_SIZE);
                g2.setStroke(MEDIUM_STROKE);

                java.awt.geom.GeneralPath flash = new java.awt.geom.GeneralPath();
                flash.moveTo(origin.x + 9, origin.y + 4);
                flash.lineTo(origin.x + 11, origin.y + 4);
                flash.lineTo(origin.x + 8, origin.y + 8);
                flash.lineTo(origin.x + 13, origin.y + 7);
                flash.lineTo(origin.x + 10, origin.y + 12);
                flash.lineTo(origin.x + 11, origin.y + 8);
                flash.lineTo(origin.x + 7, origin.y + 10);
                flash.lineTo(origin.x + 9, origin.y + 4);

                g2.setColor(java.awt.Color.BLACK);
                g2.fill(flash);
                g2.draw(flash);
                break;

            default:
                break;
        }

        g2.dispose();

        return markerImage;
    }

    private java.awt.image.BufferedImage createCheckMarkImage()
    {
        java.awt.image.BufferedImage markerImage = new java.awt.image.BufferedImage(CHECK_MARKER_SIZE + 4, CHECK_MARKER_SIZE + 4, java.awt.image.BufferedImage.TYPE_INT_ARGB);
        java.awt.Graphics2D g2 = (java.awt.Graphics2D) markerImage.getGraphics();
        g2.setRenderingHint(java.awt.RenderingHints.KEY_STROKE_CONTROL, java.awt.RenderingHints.VALUE_STROKE_PURE);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_ANTIALIASING, java.awt.RenderingHints.VALUE_ANTIALIAS_ON);

        java.awt.Point origin = new java.awt.Point(0, 0);

        java.awt.Color light = de.jugms.sd.tools.SDGlobals.INSTANCE.getActiveGradient().getLight();
        java.awt.Color dark = de.jugms.sd.tools.SDGlobals.INSTANCE.getActiveGradient().getDark();

        java.awt.GradientPaint gradientBackground = new java.awt.GradientPaint(new java.awt.Point(origin.x + 2, origin.y + 2), light, new java.awt.Point(origin.x + 2, origin.y + 18), dark);
        java.awt.RadialGradientPaint gradientShadow = new java.awt.RadialGradientPaint(new java.awt.Point(origin.x + CHECK_MARKER_SIZE / 2 + 3, origin.y + CHECK_MARKER_SIZE / 2 + 3), 7.5f, new float[]
            {
                0.0f,
                1.0f
            }, new java.awt.Color[]
            {
                new java.awt.Color(0, 0, 0, 255),
                new java.awt.Color(0, 0, 0, 20)
            });        

        // Shadow
        g2.setPaint(gradientShadow);
        g2.fillOval(origin.x + 4, origin.y + 6, CHECK_MARKER_SIZE, CHECK_MARKER_SIZE);

        // Marker
        g2.setPaint(gradientBackground);
        g2.fillOval(origin.x + 2, origin.y + 2, CHECK_MARKER_SIZE, CHECK_MARKER_SIZE);
        g2.setPaint(java.awt.Color.WHITE);
        g2.setStroke(MEDIUM_STROKE);
        g2.drawOval(origin.x + 1, origin.y + 1, CHECK_MARKER_SIZE, CHECK_MARKER_SIZE);

        g2.drawLine(origin.x + 5, origin.y + 9, origin.x + 8, origin.y + 12);
        g2.drawLine(origin.x + 8, origin.y + 12, origin.x + 12, origin.y + 6);

        g2.dispose();

        return markerImage;
    }

    private java.awt.image.BufferedImage createOkMarkerImage()
    {
        java.awt.image.BufferedImage markerImage = new java.awt.image.BufferedImage(OK_MARKER_WIDTH * 2, OK_MARKER_HEIGHT * 2, java.awt.image.BufferedImage.TYPE_INT_ARGB);
        java.awt.Graphics2D g2 = (java.awt.Graphics2D) markerImage.getGraphics();
        g2.setRenderingHint(java.awt.RenderingHints.KEY_STROKE_CONTROL, java.awt.RenderingHints.VALUE_STROKE_PURE);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_ANTIALIASING, java.awt.RenderingHints.VALUE_ANTIALIAS_ON);

        g2.translate(OK_MARKER_WIDTH / 2, OK_MARKER_HEIGHT / 2);
        g2.rotate(20 * Math.PI / 180);        

        java.awt.Point origin = new java.awt.Point(0, 0);

        java.awt.Color light = de.jugms.sd.tools.SDGlobals.INSTANCE.getActiveGradient().getLight();
        java.awt.Color dark = de.jugms.sd.tools.SDGlobals.INSTANCE.getActiveGradient().getDark();

        java.awt.GradientPaint gradientBackground = new java.awt.GradientPaint(new java.awt.Point(origin.x + 2, origin.y + 2), light, new java.awt.Point(origin.x + 2, origin.y + 18), dark);

        // Shadow
        for (int i = 6; i > 0; i--)
        {
            g2.setColor(new java.awt.Color(0, 0, 0, i * 33));
            g2.fillOval(origin.x + 4, origin.y + 5, OK_MARKER_WIDTH - i, OK_MARKER_HEIGHT - i);
        }

        g2.setPaint(gradientBackground);
        g2.fillOval(origin.x, origin.y, OK_MARKER_WIDTH, OK_MARKER_HEIGHT);
        g2.setColor(java.awt.Color.WHITE);
        g2.setStroke(BIG_STROKE);
        g2.drawOval(origin.x, origin.y, OK_MARKER_WIDTH, OK_MARKER_HEIGHT);

        g2.setFont(new java.awt.Font("Arial", 1, 11));
        java.awt.FontMetrics metrics = g2.getFontMetrics();
        java.awt.geom.Rectangle2D textRect = metrics.getStringBounds("OK", g2);
        g2.drawString("OK", (int) (OK_MARKER_WIDTH - textRect.getWidth() / 2) - (OK_MARKER_WIDTH / 2) + 1, (int) ((OK_MARKER_HEIGHT - textRect.getHeight()) / 2 + metrics.getHeight() - 2));

        g2.dispose();

        return markerImage;
    }

    private java.awt.image.BufferedImage createLogoImage()
    {
        java.awt.image.BufferedImage jugImage = new java.awt.image.BufferedImage(460 + 40, 267 + 40, java.awt.image.BufferedImage.TYPE_INT_ARGB);
        java.awt.Graphics2D g2 = jugImage.createGraphics();
        g2.setRenderingHint(java.awt.RenderingHints.KEY_STROKE_CONTROL, java.awt.RenderingHints.VALUE_STROKE_PURE);
        g2.setRenderingHints(HINTS);

        g2.translate(20, 20);

        java.awt.geom.Point2D start = new java.awt.geom.Point2D.Float(0, 102);
        java.awt.geom.Point2D stop = new java.awt.geom.Point2D.Float(0, 267);

        final float[] FRACTIONS =
        {
            0.0f,
            1.0f};

        final java.awt.Color[] COLORS =
        {
            new java.awt.Color(143,210,0,LOGO_ALPHA),
            new java.awt.Color(56,172,0,LOGO_ALPHA)
        };

        java.awt.LinearGradientPaint jugGradient = new java.awt.LinearGradientPaint(start, stop, FRACTIONS, COLORS);

        java.awt.geom.GeneralPath j = new java.awt.geom.GeneralPath();
        j.moveTo(132, 102);
        j.quadTo(97,102, 97, 136);
        j.lineTo(97, 184);
        j.quadTo(93, 229, 48, 234);
        j.lineTo(32, 234);
        j.quadTo(-1, 234, 0, 267);
        j.lineTo(48, 267);
        j.quadTo(127, 263, 132, 184);
        j.lineTo(132, 102);

        java.awt.geom.GeneralPath ug = new java.awt.geom.GeneralPath();
        ug.moveTo(139, 102);
        ug.lineTo(139, 184);
        ug.quadTo(142, 265, 223, 267);
        ug.quadTo(282, 265, 299, 217);
        ug.quadTo(318, 265, 376, 267);
        ug.quadTo(449, 268, 456, 197);
        ug.lineTo(460, 149);
        ug.quadTo(425, 150, 425, 184);
        ug.quadTo(423, 231, 376, 234);
        ug.quadTo(330, 231, 328, 184);
        ug.quadTo(330, 137, 376, 135);
        ug.lineTo(393, 135);
        ug.quadTo(425, 135, 425, 102);
        ug.lineTo(376, 102);
        ug.quadTo(318, 104, 306, 140);
        ug.lineTo(306, 102);
        ug.quadTo(272, 102, 272, 136);
        ug.lineTo(272, 184);
        ug.quadTo(269, 231, 223, 234);
        ug.quadTo(176, 231, 174, 184);
        ug.lineTo(174, 136);
        ug.quadTo(174, 102, 139, 102);

        java.awt.geom.GeneralPath beanLeft = new java.awt.geom.GeneralPath();
        beanLeft.moveTo(220, 117);
        beanLeft.lineTo(214, 117);
        beanLeft.quadTo(189, 122, 186, 146);
        beanLeft.lineTo(186, 192);
        beanLeft.quadTo(189, 216, 214, 222);
        beanLeft.lineTo(220, 222);
        beanLeft.lineTo(220, 117);

        java.awt.geom.GeneralPath beanRight = new java.awt.geom.GeneralPath();
        beanRight.moveTo(227, 117);
        beanRight.lineTo(227, 222);
        beanRight.lineTo(233, 222);
        beanRight.quadTo(257, 216, 261, 192);
        beanRight.lineTo(261, 146);
        beanRight.quadTo(258, 122, 233, 117);
        beanRight.lineTo(227, 117);

        java.awt.geom.GeneralPath m = new java.awt.geom.GeneralPath();
        m.moveTo(228, 0);
        m.quadTo(222, 14, 227, 28);
        m.quadTo(240, 50, 242, 69);
        m.quadTo(243, 94, 218, 107);
        m.quadTo(240, 82, 228, 55);
        m.lineTo(219, 42);
        m.lineTo(213, 55);
        m.lineTo(216, 62);
        m.quadTo(218, 71, 210, 82);
        m.quadTo(206, 88, 197, 95);
        m.quadTo(205, 84, 208, 72);
        m.quadTo(207, 62, 201, 55);
        m.lineTo(192, 45);
        m.quadTo(181, 72, 169, 83);
        m.quadTo(179, 72, 190, 41);
        m.quadTo(189, 32, 200, 16);
        m.quadTo(194, 29, 202, 40);
        m.lineTo(212, 53);
        m.lineTo(217, 38);
        m.lineTo(214, 30);
        m.quadTo(213, 24, 213, 19);
        m.quadTo(215, 7, 228, 0);

        java.awt.geom.GeneralPath s = new java.awt.geom.GeneralPath();
        s.moveTo(258, 12);
        s.quadTo(239, 18, 244, 36);
        s.quadTo(246, 40 , 254, 52);
        s.quadTo(259, 60, 260, 70);
        s.quadTo(260, 82, 252, 93);
        s.quadTo(268, 79, 267, 63);
        s.quadTo(264, 51, 258, 44);
        s.quadTo(252, 37, 250, 28);
        s.quadTo(250, 21, 258, 12);

        g2.setPaint(jugGradient);
        g2.fill(j);
        g2.fill(ug);

        g2.setColor(new java.awt.Color(106, 46, 17, LOGO_ALPHA));
        g2.fill(beanLeft);
        g2.fill(beanRight);

        g2.setColor(new java.awt.Color(232, 53, 26, LOGO_ALPHA));
        g2.fill(m);
        g2.fill(s);

        return jugImage;
    }

    private java.awt.image.BufferedImage createReflectionImage(java.awt.image.BufferedImage sourceImage)
    {
        float opacity = 0.5f;
        float fadeHeight = 0.7f;

        java.awt.image.BufferedImage reflectionImage = new java.awt.image.BufferedImage(sourceImage.getWidth(), sourceImage.getHeight(), java.awt.image.BufferedImage.TYPE_INT_ARGB);

        java.awt.Graphics2D g2 = (java.awt.Graphics2D) reflectionImage.getGraphics();
        g2.setRenderingHint(java.awt.RenderingHints.KEY_STROKE_CONTROL, java.awt.RenderingHints.VALUE_STROKE_PURE);

        g2.translate(0, sourceImage.getHeight());
        g2.scale(1, -1);
        g2.drawRenderedImage(sourceImage, null);
        g2.setComposite(java.awt.AlphaComposite.getInstance(java.awt.AlphaComposite.DST_IN));
        g2.setPaint(new java.awt.GradientPaint(0, sourceImage.getHeight() * fadeHeight, new java.awt.Color(0.0f, 0.0f, 0.0f, 0.0f), 0, sourceImage.getHeight(), new java.awt.Color(0.0f, 0.0f, 0.0f, opacity)));
        g2.fillRect(0, 0, sourceImage.getWidth(), sourceImage.getHeight());
        g2.dispose();

        return reflectionImage;
    }

    private java.awt.image.BufferedImage createGlowImage()
    {
        java.awt.image.BufferedImage jugImage = new java.awt.image.BufferedImage(460 + 40, 267 + 40, java.awt.image.BufferedImage.TYPE_INT_ARGB);
        java.awt.Graphics2D g2 = jugImage.createGraphics();
        g2.setRenderingHint(java.awt.RenderingHints.KEY_STROKE_CONTROL, java.awt.RenderingHints.VALUE_STROKE_PURE);
        g2.setRenderingHints(HINTS);

        g2.translate(20, 20);

        // JUG Logo

        java.awt.geom.GeneralPath j = new java.awt.geom.GeneralPath();
        j.moveTo(132, 102);
        j.quadTo(97,102, 97, 136);
        j.lineTo(97, 184);
        j.quadTo(93, 229, 48, 234);
        j.lineTo(32, 234);
        j.quadTo(-1, 234, 0, 267);
        j.lineTo(48, 267);
        j.quadTo(127, 263, 132, 184);
        j.lineTo(132, 102);

        java.awt.geom.GeneralPath ug = new java.awt.geom.GeneralPath();
        ug.moveTo(139, 102);
        ug.lineTo(139, 184);
        ug.quadTo(142, 265, 223, 267);
        ug.quadTo(282, 265, 299, 217);
        ug.quadTo(318, 265, 376, 267);
        ug.quadTo(449, 268, 456, 197);
        ug.lineTo(460, 149);
        ug.quadTo(425, 150, 425, 184);
        ug.quadTo(423, 231, 376, 234);
        ug.quadTo(330, 231, 328, 184);
        ug.quadTo(330, 137, 376, 135);
        ug.lineTo(393, 135);
        ug.quadTo(425, 135, 425, 102);
        ug.lineTo(376, 102);
        ug.quadTo(318, 104, 306, 140);
        ug.lineTo(306, 102);
        ug.quadTo(272, 102, 272, 136);
        ug.lineTo(272, 184);
        ug.quadTo(269, 231, 223, 234);
        ug.quadTo(176, 231, 174, 184);
        ug.lineTo(174, 136);
        ug.quadTo(174, 102, 139, 102);

        java.awt.geom.GeneralPath beanLeft = new java.awt.geom.GeneralPath();
        beanLeft.moveTo(220, 117);
        beanLeft.lineTo(214, 117);
        beanLeft.quadTo(189, 122, 186, 146);
        beanLeft.lineTo(186, 192);
        beanLeft.quadTo(189, 216, 214, 222);
        beanLeft.lineTo(220, 222);
        beanLeft.lineTo(220, 117);

        java.awt.geom.GeneralPath beanRight = new java.awt.geom.GeneralPath();
        beanRight.moveTo(227, 117);
        beanRight.lineTo(227, 222);
        beanRight.lineTo(233, 222);
        beanRight.quadTo(257, 216, 261, 192);
        beanRight.lineTo(261, 146);
        beanRight.quadTo(258, 122, 233, 117);
        beanRight.lineTo(227, 117);

        java.awt.geom.GeneralPath m = new java.awt.geom.GeneralPath();
        m.moveTo(228, 0);
        m.quadTo(222, 14, 227, 28);
        m.quadTo(240, 50, 242, 69);
        m.quadTo(243, 94, 218, 107);
        m.quadTo(240, 82, 228, 55);
        m.lineTo(219, 42);
        m.lineTo(213, 55);
        m.lineTo(216, 62);
        m.quadTo(218, 71, 210, 82);
        m.quadTo(206, 88, 197, 95);
        m.quadTo(205, 84, 208, 72);
        m.quadTo(207, 62, 201, 55);
        m.lineTo(192, 45);
        m.quadTo(181, 72, 169, 83);
        m.quadTo(179, 72, 190, 41);
        m.quadTo(189, 32, 200, 16);
        m.quadTo(194, 29, 202, 40);
        m.lineTo(212, 53);
        m.lineTo(217, 38);
        m.lineTo(214, 30);
        m.quadTo(213, 24, 213, 19);
        m.quadTo(215, 7, 228, 0);

        java.awt.geom.GeneralPath s = new java.awt.geom.GeneralPath();
        s.moveTo(258, 12);
        s.quadTo(239, 18, 244, 36);
        s.quadTo(246, 40 , 254, 52);
        s.quadTo(259, 60, 260, 70);
        s.quadTo(260, 82, 252, 93);
        s.quadTo(268, 79, 267, 63);
        s.quadTo(264, 51, 258, 44);
        s.quadTo(252, 37, 250, 28);
        s.quadTo(250, 21, 258, 12);

        float strokeWidth = 20;

        for (float alpha = 0.0f ; alpha <= 0.2f; alpha += 0.01f)
        {            
            g2.setColor(new java.awt.Color(0.5608f,0.8235f,0.0f,alpha));
            g2.setStroke(new java.awt.BasicStroke(strokeWidth));
            g2.draw(j);
            g2.draw(ug);

            g2.setColor(new java.awt.Color(0.4157f, 0.1804f, 0.0667f, alpha));
            g2.draw(beanLeft);
            g2.draw(beanRight);

            g2.setColor(new java.awt.Color(0.9099f, 0.2078f, 0.1019f, alpha));
            g2.draw(m);
            g2.draw(s);            
            strokeWidth -= 1.0f;
        }
        
        jugImage = getBlur().filter(jugImage, null);
        return jugImage;
    }

    private java.awt.image.BufferedImageOp getBlur()
    {
        final float[] BLUR_KERNEL =
        {
            1/12f, 1/12f, 1/12f,
            1/12f, 1/12f, 1/12f,
            1/12f, 1/12f, 1/12f
        };
        return new java.awt.image.ConvolveOp(new java.awt.image.Kernel(3, 3, BLUR_KERNEL));
    }

    private Thread createCheckMarkerRemover(final javax.swing.JComponent component)
    {
        Thread remover = null;
        if (component != null)
        {
            remover = new Thread(new java.lang.Runnable()
            {
                @Override
                public void run()
                {
                    try
                    {                        
                        Thread.sleep(1500);
                        float tmpAlpha = 1.0f;

                        if (checkMarkerAlphaMap.get(component) != null)
                            tmpAlpha = checkMarkerAlphaMap.get(component);                        

                        while (tmpAlpha > 0)
                        {
                            checkMarkerAlphaMap.put(component, tmpAlpha);

                            // Repaint here is only needed if we do not use
                            // the global animation timer
//                            javax.swing.SwingUtilities.invokeLater(new java.lang.Runnable()
//                            {
//
//                                @Override
//                                public void run()
//                                {
//                                    repaint();
//                                }
//                            });
                            Thread.sleep(50);
                            tmpAlpha -= 0.1f;
                        }
                        removeCheckMarker(component);                        
                    }
                    catch (java.lang.NullPointerException exception)
                    {
                    }
                    catch (InterruptedException exception)
                    {
                        removeCheckMarker(component);
                    }
                }
            });
            removerThreadMap.put(component, remover);
            return remover;
        }

        return null;
    }

    private Thread createFadingAnimation(final boolean fadeToGray)
    {
        Thread fader = new Thread(new java.lang.Runnable()
        {
            @Override
            public void run()
            {
                try
                {
                    int fadingAlpha = fadingColor.getAlpha();

                    // Fade background to transparent
                    if (!fadeToGray)
                    {                        
                        while (fadingAlpha > 0)
                        {
                            Thread.sleep(50);                            
                            fadingColor = new java.awt.Color(0,0,0,fadingAlpha);
                            fadingAlpha -= 10;
                            if (currentLogoAlpha > 0.0625f)
                            {
                                currentLogoAlpha -= 0.0625f;
                                currentLogoScale -= 0.05;
                            }
                            repaint();
                        }
                        fadingColor = new java.awt.Color(0,0,0,0);                        
                        backgroundDark = false;                     
                        repaint();
                    }

                    // Fade background to gray
                    if (fadeToGray)
                    {                        
                        while (fadingAlpha < 200)
                        {
                            Thread.sleep(50);                            
                            fadingColor = new java.awt.Color(0,0,0,fadingAlpha);
                            fadingAlpha += 10;
                            if (currentLogoAlpha < 0.9375f)
                            {
                                currentLogoAlpha += 0.0625f;
                                currentLogoScale += 0.05;
                            }                            
                            repaint();
                        }
                        fadingColor = new java.awt.Color(0,0,0,200);
                        backgroundDark = true;                     
                        repaint();
                    }
                }
                catch (java.lang.NullPointerException exception)
                {
                }
                catch (InterruptedException exception)
                {
                }
            }
        });

        if (fader == null)
            return new Thread();
        else
            return fader;
    }

    private Thread createPulsatingAnimation()
    {
        if (pulser != null && pulser.isAlive())
        {
            return pulser;
        }
        else
        {
            pulser = new Thread(new java.lang.Runnable()
            {
                @Override
                public void run()
                {
                    try
                    {
                        float alphaAmount = 0.05f;
                        while (disabled)
                        {
                            Thread.sleep(50);
                            if (currentGlowAlpha > 0.95f)
                                alphaAmount = -0.05f;
                            if (currentGlowAlpha < 0.05f)
                                alphaAmount = 0.05f;
                            currentGlowAlpha += alphaAmount;

                            repaint();
                        }
                    }
                    catch (InterruptedException exception)
                    {
                    }
                }
            });

            if (pulser == null)
                return new Thread();
            else
                return pulser;
        }
    }

    @Override
    public String toString()
    {
        return "SDGlassPane";
    }
}
